<?php

namespace FiloBlu\FreeShippingOrderInfo\Observer;

/**
 * Class SetIsFreeShippingCouponObserver
 * @package FiloBlu\FreeShippingOrderInfo\Observer
 */
class SetIsFreeShippingCouponObserver implements \Magento\Framework\Event\ObserverInterface
{
    /**
     * @var \Psr\Log\LoggerInterface
     */
    protected $_logger;

    /**
     * @var \FiloBlu\FreeShippingOrderInfo\Helper\Order
     */
    protected $_orderHelper;

    /**
     * SetIsFreeShippingCouponObserver constructor.
     * @param \FiloBlu\FreeShippingOrderInfo\Helper\Order $orderHelper
     * @param \Psr\Log\LoggerInterface $logger
     */
    public function __construct(
        \FiloBlu\FreeShippingOrderInfo\Helper\Order $orderHelper,
        \Psr\Log\LoggerInterface $logger)
    {
        $this->_logger = $logger;
        $this->_orderHelper = $orderHelper;
    }

    /**
     * @param \Magento\Framework\Event\Observer $observer
     * @return $this|void
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        try {
            $this->_orderHelper->updateFreeShippingFlag($observer->getOrder());
        } catch (\Exception $e) {
            $this->_logger->critical($e->getMessage());
        }

        return $this;
    }
}